sampler sampler0_ : register( s0 );

struct PS_INPUT
{
	float4 diffuse	: COLOR0;
	float2 texCoord	: TEXCOORD0;
	float2 vPos	: VPOS;
};

struct PS_OUTPUT
{
	float4 color	: COLOR0;
};

float random(float2 p){return frac(cos(dot(p,float2(23.14069263277926,2.665144142690225)))*12345.6789);}

float strength;

PS_OUTPUT PS( PS_INPUT In ) : COLOR0
{
	PS_OUTPUT Out;

	float2 uv;
		uv.x = In.texCoord.x;
		uv.y = In.texCoord.y;

	uv.x += (random(uv)-0.5)*(strength/100);
	uv.y += (random(uv)-0.5)*(strength/100);

	float4 colorTexture = tex2D(sampler0_, uv);
	float4 colorDiffuse = In.diffuse;
	float4 color = colorTexture * colorDiffuse;

	Out.color = color;

	return Out;
}

technique Render
{
	pass P0
	{
		PixelShader = compile ps_3_0 PS();
	}
}

