sampler sampler0_ : register( s0 );

float _rwd = 1024;
float _rht = 512; 

float pi = 3.14159265;
float v = 2.11655518;

float2 fragPos;
float fragStrength;
float iTime;

float newDist(float dist)
{
    return (15.0 * pi * dist + max(0,0.15 * fragStrength * sin(15.0 * pi * dist - 10.0 * iTime) / (dist))) / 15.0 / pi;
}

struct PS_INPUT
{
	float4 diffuse	: COLOR0;
	float2 texCoord	: TEXCOORD0;
	float2 vPos	: VPOS;
};

struct PS_OUTPUT
{
	float4 color	: COLOR0;
};

PS_OUTPUT PS( PS_INPUT In ) : COLOR0
{
	PS_OUTPUT Out;

	float2 pos;
		pos.x = fragPos.x / _rwd;
		pos.y = fragPos.y / _rht;

	float2 uv;
		uv.x = In.texCoord.x;
		uv.y = In.texCoord.y;

	float dist = sqrt((uv.x - pos.x) * (uv.x - pos.x) + (uv.y - pos.y) * (uv.y - pos.y));

	uv.xy = dist / newDist(dist) * (uv.xy - pos.xy) + pos.xy;

	float4 colorTexture = tex2D(sampler0_, uv);
	float4 colorDiffuse = In.diffuse;
	float4 color = colorTexture * colorDiffuse;

	color.a = 1;

	Out.color = color;

	return Out;
}

technique Render
{
	pass P0
	{
		PixelShader = compile ps_3_0 PS();
	}
}

